=== python/CMakeLists.txt ===
add_subdirectory(module)
add_subdirectory(test)

# add_subdirectory(python2)
add_subdirectory(python3)
