=== java/test/CMakeLists.txt ===
# -*- coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4

macro(set_testing_path)
    if( WIN32 )
        foreach( dir ${NDS_CLIENT_LIBRARY_DIRS} )
            get_filename_component( dir "${dir}/../bin" ABSOLUTE )
            file( TO_NATIVE_PATH ${dir} dir )
            list( APPEND TPATH ${dir} )
        endforeach( )
        list( APPEND TPATH  $ENV{PATH} )
        string( REPLACE ";" "\\;" TPATH "${TPATH}" )
        # message( FATAL_ERROR "DEBUG: TPATH: ${TPATH}" )
    else( WIN32 )
        set(TPATH "$ENV{PATH}")
    endif( WIN32 )
endmacro()

if ( ENABLE_SWIG_JAVA )
    include(CMakeParseArguments)
    include(UseCopyIfDifferent)

    file( TO_NATIVE_PATH ${Java_JAVA_EXECUTABLE} PROG_JAVA )
    if ( WIN32 )
        # string( REPLACE "\\" "\\\\" PROG_JAVA "${PROG_JAVA}" )
    endif( )

    get_filename_component( NDS_JAR "${CMAKE_CURRENT_BINARY_DIR}/../module/nds2.jar" ABSOLUTE )
    message( STATUS "NDS_JAR: ${NDS_JAR}" )

    set( MATLAB_TEST_FLAGS "")
    if ( MATLAB_NO_NODISPLAY )
        set ( MATLAB_TEST_FLAGS "--no-nodisplay" )
    endif ( MATLAB_NO_NODISPLAY )

    function(to_path_list var path1)
        if (WIN32)
            set(sep "\\;")
        else(WIN32)
            set(sep ":")
        endif(WIN32)
        set(result "${path1}") # First element doesn't require separator at all...
        foreach(path ${ARGN})
            set(result "${result}${sep}${path}") # ... but other elments do.
        endforeach(path)
        #list(APPEND result ${path1} ${ARGN})
        set(${var} "${result}" PARENT_SCOPE)
    endfunction(to_path_list)


    function(COMPILE_JAVA target)
        #--------------------------------------------------------------------
        # Parse the parameters
        #--------------------------------------------------------------------
        set(options)
        set(oneValueArgs)
        set(multiValueArgs SOURCES BINARY_SOURCES)
        cmake_parse_arguments( "" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
        message( STATUS "target: ${target} ARGN: ${ARGN}" )
        set(ALL_SOURCES "" )
        if( _SOURCES )
          set_source_files_properties( ${_SOURCES} PROPERTIES GENERATED TRUE )
          foreach( i ${_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _SOURCES )
        message( STATUS "BINARY_SOURCES: ${_BINARY_SOURCES}" )
        if( _BINARY_SOURCES )
            foreach( i ${_BINARY_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _BINARY_SOURCES )
        message( STATUS "ALL_SOURCES: ${ALL_SOURCES}" )
        #--------------------------------------------------------------------
        #
        #--------------------------------------------------------------------
        set(CMAKE_JAVA_COMPILE_FLAGS -source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY} )
        #-------------------------------------------------------------------
        # Get source into local build directory
        #-------------------------------------------------------------------
        if ( _SOURCES )
            copy_if_different(
                ${CMAKE_CURRENT_SOURCE_DIR}
                ${CMAKE_CURRENT_BINARY_DIR}
                "${_SOURCES}"
                JavaStageTargets "JavaStage${target}" )
            add_custom_target( CopyJavaStage${target}
                ALL DEPENDS ${JavaStageTargets} )
        endif ( _SOURCES )
        #-------------------------------------------------------------------
        # Compile source
        #-------------------------------------------------------------------
        set( CMAKE_JAVA_INCLUDE_PATH ${NDS_JAR} )
        message( STATUS "DEBUG: NDS_JAR: ${NDS_JAR}" )
        add_jar( ${target}
            SOURCES ${ALL_SOURCES}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        add_dependencies( ${target} ndstesting nds2 nds2JNI )
        if( JavaStageTargets )
            add_dependencies( ${target} CopyJavaStage${target} )
        endif( JavaStageTargets )
    endfunction(COMPILE_JAVA)

    function(COMPILE_JAVA_TEST target)
        compile_java(${target} ${ARGN} )
    endfunction(COMPILE_JAVA_TEST)

    function(ADD_JAVA_TEST target)
        list(GET ARGN 0 cmd )
        set_testing_path( )
        to_path_list(java_test_jars ${CMAKE_CURRENT_BINARY_DIR}/${cmd}.jar ${NDS_JAR} )
        add_test( ${target}
            ${Java_JAVA_EXECUTABLE} -cp ${java_test_jars} -enableassertions ${CMAKE_JAVA_EXTRA_FLAGS} ${ARGN} )
        set( env 
              "PATH=${TPATH}"
              "JAVA=${PROG_JAVA}"
              ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
        set_test_properties( ${target}
            ENVIRONMENT "${env}"
            )
    endfunction(ADD_JAVA_TEST)

    #-----------------------------------------------------------------------
    # Need to build some scripts since they depend on dynamic data.
    #-----------------------------------------------------------------------

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_java.java.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_java.java
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_matlab.m.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_matlab.m
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/unittest.java
                    ${CMAKE_CURRENT_BINARY_DIR}/ndstesting/unittest.java
                    COPYONLY )
    #-----------------------------------------------------------------------
    #-----------------------------------------------------------------------
    compile_java(
        ndstesting
        BINARY_SOURCES
            "ndstesting/unittest.java" )
    #-----------------------------------------------------------------------
    # Run tests that depend on python
    #-----------------------------------------------------------------------
    if( PYTHON_DFLT_EXECUTABLE )
        #-------------------------------------------------------------------
        # All of these require python to run
        #-------------------------------------------------------------------
        function(null_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                if (NOT IS_ABSOLUTE ${command})
                    if ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                    elseif ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                    endif ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                endif (NOT IS_ABSOLUTE ${command})
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --null-server
                        "${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                # message( FATAL_ERROR "DEBUG: env: ${env}" )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                        )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(null_server_test)

        function(mock_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_BINARY_DIR})
            else( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_SOURCE_DIR})
            endif( ${COMMAND_EXT} STREQUAL ".class" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --nds1-mock-server
                        "${COMMAND_DIR}/${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                          )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(mock_server_test)

        function(replay_server_test name command json)
            if ( REPLAY_BLOB_CACHE_DIR )
                set_nds_protocols(protocols ${name})
                foreach ( proto ${protocols} )
                    set(test_name "${name}${proto}_")
                    set( _include_test TRUE )
                    get_filename_component( COMMAND_EXT ${command} EXT )
                    if( ${COMMAND_EXT} STREQUAL ".m" )
                        if ( NOT PROG_MATLAB )
                            set( _include_test FALSE )
                        endif ( NOT PROG_MATLAB )
                    endif( ${COMMAND_EXT} STREQUAL ".m" )
                    if ( _include_test )
                        set_testing_path( )
                        add_test(
                            NAME ${test_name}
                            COMMAND
                                ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                                --matlab=${PROG_MATLAB}
                                ${MATLAB_TEST_FLAGS}
                                --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar
                                --replay-server
                                --replay-json-filename ${json}
                                --replay-protocol ${proto}
                                "${CMAKE_CURRENT_SOURCE_DIR}/${command}" ${ARGN} )
                        set( env
