=== debian/changelog ===
nds2-client-swig (0.16.13-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 15 Aug 2025 14:30:00 -0700

nds2-client-swig (0.16.12-1.3) unstable; urgency=low

  * Updated code as described in the ChangeLog.md
  * Added --with=python3 to catch-all rule
  * Added python3-numpy dependency
  * Keep octave and python2 disabled

 -- Steffen Grunewald <steffen.grunewald@ligo.org>  Wed, 23 Aug 2023 14:00:00 +0200

nds2-client-swig (0.16.12-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Tue, 02 Aug 2022 09:48:44 -0700

nds2-client-swig (0.16.11-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Fri, 14 Jan 2022 10:02:40 -0800

nds2-client-swig (0.16.10-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Thu, 05 Aug 2021 08:10:05 -0700

nds2-client-swig (0.16.9-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 05 May 2021 18:32:07 -0700

nds2-client-swig (0.16.8-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 13 Aug 2020 15:50:17 -0700

nds2-client-swig (0.16.7-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 19 Mar 2020 11:27:38 -0700

nds2-client-swig (0.16.6-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 27 Sep 2019 14:09:47 -0700

nds2-client-swig (0.16.5-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 07 Mar 2019 11:26:54 -0800

nds2-client-swig (0.16.4-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 20 Feb 2019 11:19:22 -0800

nds2-client-swig (0.16.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 02 Nov 2018 11:16:25 -0700

nds2-client-swig (0.16.2-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Mon, 22 Oct 2018 09:25:14 -0700

nds2-client-swig (0.16.1-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 03 Aug 2018 09:38:11 -0700

nds2-client-swig (0.16.0-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 02 Aug 2018 13:32:57 -0700

nds2-client-swig (0.15.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 14 Mar 2018 13:39:41 -0700
