=== debian/control ===
Source: nds2-client-swig
Section: net
Priority: optional
Maintainer: Edward Maros <ed.maros@ligo.org>
Build-Depends:
 debhelper (>= 9),
 dh-python,
 cmake,
 gawk,
 pkg-config,
 swig (>= 3.0.7),
 python3-all-dev,
 python3-numpy,
 default-jdk,
 libnds2-client-dev (>= 0.16.9)
# octave | octave3.2 | octave3.0,
# liboctave-dev | octave3.2-headers | octave3.0-headers,
# python-all-dev,
# python-numpy,
Standards-Version: 3.9.8
#X-Python-Version: >= 2.7
X-Python3-Version: >= 3.5
Homepage: https://wiki.ligo.org/Computing/NDSClient

Package: nds2-client-swig
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 krb5-user
Suggests:
 libnds2-client-java,
 libnds2-client-matlab,
 python3-nds2-client
# octave-nds2-client,
# python-nds2-client,
Description: NDS2 client binaries
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes some client binary examples.

Package: libnds2-client-java
Section: java
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client java interface
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated java bindings, which are
 also usable from Matlab.

# Package: octave-nds2-client
# Architecture: any
# Depends:
#  libnds2-client (>= 0.16.9),
#  octave,
#  ${shlibs:Depends},
#  ${misc:Depends}
# Description: NDS2 client octave bindings
#  The Network Data Server (NDS) is a TCP/IP protocol for retrieving
#  online or archived data from thousands of instrument channels at LIGO
#  (Laser Interferometer Gravitational-Wave Observatory) sites and data
#  analysis clusters.  Version 2 of the protocol includes communication
#  with Kerberos and GSSAPI.
#  .
#  This package includes the SWIG-generated octave bindings.

#Package: python-nds2-client
#Section: python
#Architecture: any
#Depends: ${python:Depends},
# libnds2-client (>= 0.16.9),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: NDS2 client Python bindings
# The Network Data Server (NDS) is a TCP/IP protocol for retrieving
# online or archived data from thousands of instrument channels at LIGO
# (Laser Interferometer Gravitational-Wave Observatory) sites and data
# analysis clusters.  Version 2 of the protocol includes communication
# with Kerberos and GSSAPI.
# .
# This package includes the SWIG-generated python bindings.

Package: python3-nds2-client
Section: python
Architecture: any
Depends: ${python3:Depends},
 libnds2-client (>= 0.16.9),
 python3-numpy,
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client Python 3 bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated python bindings.

Package: libnds2-client-matlab
Architecture: any
Depends:
 libnds2-client-java (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client MATLAB interface
 This provides MATLAB wrappers for the nds2 client

Package: nds2-client-swig-all
Architecture: any
Depends:
 ${misc:Depends},
 libnds2-client-java (= ${binary:Version}),
 libnds2-client-matlab (= ${binary:Version}),
 python3-nds2-client (= ${binary:Version})
# octave-nds2-client (= ${binary:Version}),
# python-nds2-client (= ${binary:Version}),
Description: NDS2 meta package
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package installs all NDS2 client packages, including libraries,
 language bindings, binary interface, and documentation.
