=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --with=python3

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_SYSCONFDIR=etc -DCMAKE_INSTALL_FULL_SYSCONFDIR=/etc -DENABLE_SWIG_OCTAVE=FALSE -DENABLE_SWIG_PYTHON2=no -DENABLE_SWIG_PYTHON3=yes
